#pragma once

#ifdef _MSC_VER
#pragma pack(push,8)
#endif  /* _MSC_VER */

#if defined (_M_MPPC)
#define BUFSIZ  4096
#else  /* defined (_M_MPPC) */
#define BUFSIZ  512
#endif  /* defined (_M_MPPC) */

#ifndef _INTERNAL_IFSTRIP_
/*
 * Real default size for stdio buffers
 */
#define _INTERNAL_BUFSIZ    4096
#define _SMALL_BUFSIZ       512
#endif  /* _INTERNAL_IFSTRIP_ */

#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif  /* _SIZE_T_DEFINED */


#ifndef _WCHAR_T_DEFINED
typedef unsigned short wchar_t;
#define _WCHAR_T_DEFINED
#endif  /* _WCHAR_T_DEFINED */

#ifndef NULL
#define NULL    ((void *)0)
#endif  /* NULL */

#ifndef HANDLE
typedef void * HANDLE;
#endif

#ifndef DWORD
#define DWORD unsigned int
#endif

#ifndef REG1
#define REG1 register
#endif

#ifndef REG2
#define REG2 register
#endif

#ifndef REG3
#define REG3 register
#endif

typedef char *  va_list;

#ifndef _INTSIZEOF(n)
#define _INTSIZEOF(n)   ( (sizeof(n) + sizeof(int) - 1) & ~(sizeof(int) - 1) )
#endif

#ifndef va_start(ap,v)
#define va_start(ap,v)  ( ap = (va_list)&v + _INTSIZEOF(v) )
#endif

#ifndef va_arg(ap,t)
#define va_arg(ap,t)    ( *(t *)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)) )
#endif

#ifndef va_end(ap)
#define va_end(ap)      ( ap = (va_list)0 )
#endif

#define _IOBIN          0x0000
#define _IOREAD         0x0001
#define _IOWRT          0x0002
#define _IORW           0x0004
#define _IOTEXT         0x0008
#define _IOEOF          0x0010
#define _IOERR          0x0020
#define _IOAPPEND       0x0200

#define inuse(s) ((s)->flag & (_IOREAD|_IOWRT|_IORW))
//#define feof(s)     ((s)->flag & _IOEOF)
#define __max(a,b)  (((a) > (b)) ? (a) : (b))
#define __min(a,b)  (((a) < (b)) ? (a) : (b))


typedef struct _minicrt_file
{
    HANDLE hFile;
	char *ptr;
	DWORD flag;
	int   cnt;
} FILE;

#define SEEK_CUR    1
#define SEEK_END    2
#define SEEK_SET    0

//=======================memory=====================
void * malloc(unsigned int size);
void * calloc(unsigned int nitems, unsigned int size);
void * realloc(void * p, unsigned int size);
unsigned int _msize(void * p);
void free(void * p);
void *memset(void *dest, int c, size_t count);
void *memcpy(void *dest, const void *src, size_t count);
void *memmove(void *dest, const void *src, size_t count);
//=======================files======================
FILE *fopen(const char *filename, const char *mode);
FILE *freopen( const char *path, const char *mode, FILE * fp);
int fclose(FILE *fp);
int feof(FILE *fp);
int fseek(FILE * fp, long offset, int origin);
long ftell(FILE *fp);
long _filelength(FILE * fp);
char *fgets(char *str, int n, FILE * fp);
int fputs(const char *str, FILE * fp);
DWORD fread(void * buffer, DWORD size, DWORD count, FILE * fp);
DWORD fwrite(const void * buffer, DWORD size, DWORD count, FILE * fp);
int remove(const char *path);
int fprintf(FILE *fp, const char * format, ...);
int setvbuf(FILE * fp, char *buffer, int mode, size_t size);
//===========================environments============
int _putenv(const char *envstring);
char *getenv(const char *varname);
char * _getpath(register const char *src, register char *dst, unsigned maxlen);
//============================printing==============
int putchar(int c);
int printf(const char *format, ...);
int sprintf(char *ptr, const char *format, ...);
int vprintf(const char *format, va_list args);
int snprintf(char *str,DWORD count,const char *fmt,...);
int vsprintf(char *ptr, const char *format, va_list ap);
int vsnprintf (char *str, DWORD count, const char *fmt, va_list args);
//================proccess==========================
void exit(int status);
void _exit(int status);
int _spawnve(register int mode, const char *name, const char * const *argv, const char * const *envp);
int _spawnvpe(int modeflag, register const char *filename, const char * const *argv, const char * const *envptr);
int _spawnle(int modeflag, const char *pathname, const char *arglist, ...);
int _spawnl(int modeflag, const char *pathname, const char *arglist, ...);
int _spawnv(int modeflag, const char *pathname, const char * const *argv);
int _spawnlpe(int modeflag, const char *filename, const char *arglist, ...);
int _spawnvp(int modeflag, REG3 const char *filename, const char * const *argv);
int _spawnlp(int modeflag, const char *filename, const char *arglist, ...);
char * strrchr (const char * string, int ch);
int system(const char *command);
int _access(const char *path, int amode);
//=======================strings===================
char *_strlwr(char * str);
char *_strupr(char *str);
size_t strlen(const char *str);
char *strcat(char *dest, const char *src);
char *strcpy(char *dest, const char *src);
char *strdup(const char *src);
unsigned int strspn(const char *str, const char *strCharSet);
char * strtok (char * string, const char * control);
int strcmp(const char *string1, const char *string2);
int strncmp(const char *string1, const char *string2, size_t count);
char *strncat(char *strDest, const char *strSource,size_t count);
char *strncpy(char *strDest, const char *strSource, size_t count);
int _strnicmp(const char *str1, const char *str2, unsigned int count);
int _stricmp(const char *str1, const char *str2);
char *_strnset(char *str, int c, size_t count);
char *_strset(char *str, int c);
char *_strrev(char *str);
char *strstr(const char *str, const char *strSearch);
char *strchr(const char *str, int c);
char *strrchr(const char *str, int c);
//====================Data conversion==========================
int abs(int n);
int tolower(int c);
int toupper(int c);
long _ftol(double f);
int atoi(const char *str);



#ifdef _MSC_VER
#pragma pack(pop)
#endif  /* _MSC_VER */
